/*
    ************************************************
    * SIMULAZIONE COLLEGAMENTI AEREI RETE MONDIALE *
		* REALIZZATO DA:                               *
		* Marco Sommella 50/482                        *
		* Giovanni Di Cecca 50/887                     *
		* Virginia Bellino 408/466                     *
		************************************************
*/


#include <malloc.h>
#include <limits.h>


/* Struttura che rappresenta un arco */
typedef struct edge
{
	int key; /* contiene l'indice del vertice entrate */
	int tipo; /* indica il tipo di arco: 1 - LDA, 2 - LNA */
	struct edge *next; /* puntatore all'adiacente successivo */
} edge;


/* Struttura che rappresenta un vertice */
typedef struct vertex
{
	int label; /* nome del vertice */
	int tipo; /* indica il tipo di vertice: 1 - HUB, 2 - LOCALE */
	int visita; /* indica se gi visitato */
	int dist; /* distanza dall'ultimo punto considerato */
	edge *next; /* puntatore a lista di adiacenza */
} vertex;

/* Rappresentazione del grafo con lista di adiacenza */
typedef struct graph
{
	int nv; /* grandezza dall'array dei vertici */
	int usati; /* numero di celle dell'array usate */
	vertex **ver; /* array di puntatori a vertici */
} graph;


/* Prototipi delle funzioni */
graph *CreaGrafo ();
vertex *CreaVertice ( int label, int tipo );
int GrafoVuoto ( graph *G );
int Adiacenti ( graph *G, int u, int v );
int VerticeValido ( graph *G, int u );
int TrovaHUB ( graph *G, int u );
graph *InserisciVertice ( graph *G, vertex *vertice );
void InserisciArco ( graph *G, int u, int v );
void InserisciArcoN_O ( graph *G, int u, int v );
void EliminaArco ( graph *G, int u, int v );
void EliminaArcoN_O ( graph *G, int u, int v );
void EliminaVertice ( graph *G, int u );
void StampaGrafo ( graph *G );
void Ampiezza ( graph *G, int start );
