/*
    ************************************************
    * SIMULAZIONE COLLEGAMENTI AEREI RETE MONDIALE *
    *              con Algoritmo BFS               *
		* REALIZZATO DA:                               *
		* Marco Sommella 50/482                        *
		* Giovanni Di Cecca 50/887                     *
		* Virginia Bellino 408/466                     *
		************************************************
*/

#include <stdio.h>
#include "grafi.c"
#include "airport.c"

main()
{
  /* per il menu */
	int in, in2;
	char scelta;

													/* INIZIALIZZAZIONE */
  graph *G = CreaGrafo ();
  G = SituazioneIniziale ( G, 20, 2 );
	ControllaPercorsi ( G );
  
												/* MENU DI SELEZIONE */
	do
	{
		system ( "CLS" );
		printf ( "************************************************\n" );
		printf ( "* SIMULAZIONE COLLEGAMENTI AEREI RETE MONDIALE *\n" );
		printf ( "*              con Algoritmo BFS               *\n" );
		printf ( "* REALIZZATO DA:                               *\n" );
		printf ( "* Marco Sommella 50/482                        *\n" );
		printf ( "* Giovanni Di Cecca 50/887                     *\n" );
		printf ( "* Virginia Bellino 408/466                     *\n" );
		printf ( "************************************************\n\n" );

    printf ( "------------------------------\n" );
		printf ( "a: Inserisci Aereoporto HUB\nb: Inserisci Aereoporto Locale\n" );
		printf ( "------------------------------\n" );
		printf ( "c: Elimina Aereoporto HUB\nd: Elimina Aereoporto Locale\n" );
		printf ( "------------------------------\n" );
		printf ( "e: Inserisci Arco LDA\nf: Elimina Arco LDA\n" );
		printf ( "------------------------------\n" );
		printf ( "s: Stampa Situazione\nq: Quit\n" );
		printf ( "------------------------------\n" );
		printf ( "Scegli: " );
		fflush ( stdin );
		scanf( "%c", &scelta );
		switch( scelta ) /* l'utente pu inserire lettere maiuscole o
												minuscole indifferentemente */
		{
			case 'A':
			case 'a':	system ( "CLS");
								printf ( "Inserisci la label ( numerica ) dell'Aereoporto da inserire: ");
								scanf ( "%d", &in );
								G = InserisciVertice ( G, CreaVertice ( in, 1 ) );
								ControllaPercorsi ( G );
                printf ( "\nInserimento Terminato.\n" );
								printf ( "Utilizzare la funzione di Stampa\n" );
                system ( "PAUSE" );
								break;
			case 'B':
			case 'b': system ( "CLS");
								printf ( "Inserisci la label ( numerica ) dell'Aereoporto da inserire: ");
								scanf ( "%d", &in );
								G = InserisciVertice ( G, CreaVertice ( in, 2 ) );
								printf ( "\nScegli tra i seguenti Aereoporti HUB a quale collegare il Locale appena creato:\n" );
								StampaHUB ( G );
								printf ( "Scegli: " );
								scanf( "%d", &in2 );
        				InserisciArcoN_O ( G, TrovaLabel ( G, in ), TrovaLabel ( G, in2 ) );
        				ControllaPercorsi ( G );
                printf ( "\nInserimento Terminato.\n" );
								printf ( "Utilizzare la funzione di Stampa\n" );
                system ( "PAUSE" );
								break;
			case 'C':
			case 'c':	system ( "CLS" );
								printf ( "Scegli tra i seguenti Aereoporti HUB quale eliminare:\n" );
								StampaHUB ( G );
								printf ( "Scegli: " );
								scanf( "%d", &in );
								EliminaVertice ( G, TrovaLabel ( G, in ) );
								ControllaPercorsi ( G );
								printf ( "\nEliminazione Terminata.\n" );
								printf ( "Utilizzare la funzione di Stampa\n" );
                system ( "PAUSE" );
								break;
			case 'D':
			case 'd': system ( "CLS" );
								printf ( "Scegli tra i seguenti Aereoporti Locali quale eliminare:\n" );
								StampaLocali ( G );
								printf ( "Scegli: " );
								scanf( "%d", &in );
								EliminaVertice ( G, TrovaLabel ( G, in ) );
                ControllaPercorsi ( G );
								printf ( "\nEliminazione Terminata.\n" );
								printf ( "Utilizzare la funzione di Stampa\n" );
                system ( "PAUSE" );
								break;
			case 'E':
			case 'e': system ( "CLS" );
								printf ( "Scegli tra i seguenti Aereoporti HUB quali collegare:\n" );
								StampaHUB ( G );
								printf ( "Scegli il primo: " );
								scanf( "%d", &in );
								printf ( "Scegli il secondo: " );
								scanf( "%d", &in2 );
        				InserisciArcoN_O ( G, TrovaLabel ( G, in ), TrovaLabel ( G, in2 ) );
        				ControllaPercorsi ( G );
								printf ( "\nCollegamento Terminato.\n" );
								printf ( "Utilizzare la funzione di Stampa\n" );
                system ( "PAUSE" );
								break;
			case 'F':
			case 'f': system ( "CLS" );
								printf ( "Scegli tra i seguenti Aereoporti HUB quali scollegare:\n" );
								StampaHUB ( G );
								printf ( "Scegli il primo: " );
								scanf( "%d", &in );
                StampaHUBAdiacenti ( G, TrovaLabel ( G, in ) );
								printf ( "Scegli il secondo: " );
								scanf( "%d", &in2 );
        				EliminaArcoN_O ( G, TrovaLabel ( G, in ), TrovaLabel ( G, in2 ) );
        				ControllaPercorsi ( G );
								printf ( "\nScollegamento Terminato.\n" );
								printf ( "Utilizzare la funzione di Stampa\n" );
                system ( "PAUSE" );
								break;
			case 'S':
			case 's': StampaGrafo ( G );
								break;
			default:	break;
		}
	}
	while ( scelta != 'q' && scelta != 'Q' );
}
