/*
    ************************************************
    * SIMULAZIONE COLLEGAMENTI AEREI RETE MONDIALE *
    *           con Algoritmo di Dijkstra          *
		* REALIZZATO DA:                               *
		* Marco Sommella 50/482                        *
		* Giovanni Di Cecca 50/887                     *
		* Virginia Bellino 408/466                     *
		************************************************
*/

#include "airport.h"

/*	Crea una situazione iniziale dove ci sono "hub" vertici di tipo hub,
		"locali" vertici locali per ogni hub. Le label sono impostate uguali
		all'indice del for +100 solo per praticit.

		INPUT:  *G - puntatore al grafo
		        hub - numero di hub che si desidera avere
		        locali - numeri di aereoporti locali che si desidera avere
		OUTPUT: ritorna il grafo modificato

*/
graph *SituazioneIniziale ( graph *G, int hub, int  locali )
{
  int i; /* indice per il for */

  srand ( time ( NULL ) );

  for ( i = 0; i < hub; i++ ) /* crea gli HUB */
  {
		G = InserisciVertice ( G, CreaVertice ( i+100, 1 ) );
	}

  for ( i = 0; i <  hub/locali; i++ ) /* crea gli archi LNA */
  {
  	InserisciArcoN_O ( G, rand() % hub,  rand() % hub );
	}

  for ( i = hub; i < ( ( hub * locali ) + hub ); i++ ) /* crea i locali e li collega */
  {
		G = InserisciVertice ( G, CreaVertice ( i+100, 2 ) );
    InserisciArcoN_O ( G, i, (i % hub) );
	}

  return G;
}


/*	Stampa tutti i vertici HUB del grafo G

		INPUT:	*G - puntatore al grafo
*/
void StampaHUB ( graph *G )
{
	int i; /* indice per il for */

	if( !GrafoVuoto ( G ) )
	{
    for (i = 0; i < G->nv; i++ )
		{
			if( G->ver[i] != NULL && G->ver[i]->tipo == 1 )
			{
				printf ( "%5d\t", G->ver[i]->label );
			}
		}
		printf ( "\n" );
	}
	else
	{
		printf("Grafo Vuoto\n");
	}
}


/*	Stampa tutti i vertici locali del grafo G

		INPUT:	*G - puntatore al grafo
*/
void StampaLocali ( graph *G )
{
	int i; /* indice per il for */

	if( !GrafoVuoto ( G ) )
	{
    for (i = 0; i < G->nv; i++ )
		{
			if( G->ver[i] != NULL && G->ver[i]->tipo == 2 )
			{
				printf ( "%5d\t", G->ver[i]->label );
			}
		}
		printf ( "\n" );
	}
	else
	{
		printf("Grafo Vuoto\n");
	}
}


/*  Stampa tutti i vertici HUB adiacenti al vertice i del grafo G

		INPUT:	*G - puntatore al grafo
		        i - posizione del vertice del quale si vogliono gli adiacenti HUB
*/
void StampaHUBAdiacenti ( graph *G, int i )
{
	edge *tmp; /* puntatore per scorrere la lista di adiacenza */

	if( !GrafoVuoto ( G ) && G->ver[i] != NULL )
	{
    tmp = G->ver[i]->next;
		while ( tmp != NULL )
		{
			if ( tmp->tipo == 1 )
			{
				printf ( "  %5d", G->ver[tmp->key]->label );
			}
			tmp = tmp->next;
		}
		printf ( "\n" );
	}
	else
	{
		printf("Grafo Vuoto\n");
	}
}
